Index: /code/branches/input/src/audio/AudioPrereqs.h
===================================================================
--- /code/branches/input/src/audio/AudioPrereqs.h	(revision 944)
+++ /code/branches/input/src/audio/AudioPrereqs.h	(revision 945)
@@ -27,7 +27,7 @@
 
 /**
- @file  AudioPrereqs.h
- @brief Contains all the necessary forward declarations for all classes, structs and enums.
- */
+  @file
+  @brief Contains all the necessary forward declarations for all classes and structs.
+*/
 
 #ifndef _AudioPrereqs_H__
Index: /code/branches/input/src/network/NetworkPrereqs.h
===================================================================
--- /code/branches/input/src/network/NetworkPrereqs.h	(revision 944)
+++ /code/branches/input/src/network/NetworkPrereqs.h	(revision 945)
@@ -27,7 +27,7 @@
 
 /**
- @file  NetworkPrereqs.h
- @brief Contains all the necessary forward declarations for all classes, structs and enums.
- */
+  @file
+  @brief Contains all the necessary forward declarations for all classes and structs.
+*/
 
 #ifndef _NetworkPrereqs_H__
@@ -84,5 +84,5 @@
   struct PacketEnvelope;
   struct QueueItem;
-  struct synchData;
+  struct syncData;
   struct synchronisableVariable;
 }
Index: /code/branches/input/src/orxonox/Orxonox.cc
===================================================================
--- /code/branches/input/src/orxonox/Orxonox.cc	(revision 944)
+++ /code/branches/input/src/orxonox/Orxonox.cc	(revision 945)
@@ -50,4 +50,5 @@
 //misc
 //#include "util/Sleep.h"
+#include "util/ArgReader.h"
 
 // audio
@@ -61,5 +62,4 @@
 
 // objects
-#include "core/ArgReader.h"
 #include "core/Debug.h"
 #include "core/Factory.h"
@@ -174,5 +174,5 @@
     std::string mode;
 
-    ArgReader ar = ArgReader(argc, argv);
+    ArgReader ar(argc, argv);
     ar.checkArgument("mode", mode, false);
     ar.checkArgument("data", this->dataPath_, false);
Index: /code/branches/input/src/orxonox/OrxonoxPrereqs.h
===================================================================
--- /code/branches/input/src/orxonox/OrxonoxPrereqs.h	(revision 944)
+++ /code/branches/input/src/orxonox/OrxonoxPrereqs.h	(revision 945)
@@ -27,7 +27,7 @@
 
 /**
- @file  OrxonoxPrereqs.h
- @brief Contains all the necessary forward declarations for all classes and structs.
- */
+  @file
+  @brief Contains all the necessary forward declarations for all classes and structs.
+*/
 
 #ifndef _OrxonoxPrereqs_H__
@@ -59,29 +59,21 @@
 //-----------------------------------------------------------------------
 
-// classes that have not yet been put into a namespace
-class InputManager;
-class SpaceShipSteering;
-
 namespace orxonox {
-  class Ambient;
-  class BaseObject;
-  class Camera;
   class GraphicsEngine;
   struct InputEvent;
   class InputEventListener;
   class InputHandler;
-  class Mesh;
+  class Orxonox;
+
+  // objects
+  class Ambient;
+  class Camera;
+  class Explosion;
+  class Fighter;
   class Model;
   class NPC;
-  class OrxListener;
-  class Orxonox;
+  class Projectile;
   class Skybox;
   class SpaceShip;
-  class Tickable;
-  class TickFrameListener;
-  template <class T>
-  class Timer;
-  class TimerBase;
-  class TimerFrameListener;
   class WorldEntity;
 
@@ -93,5 +85,16 @@
   class WeaponStation;
 
+  // tools
+  class BillboardSet;
+  class Light;
+  class Mesh;
+  template <class T>
+  class Timer;
+  class TimerBase;
+
+  // particle
   class ParticleInterface;
+
+  // hud
   class HUD;
 }
Index: de/branches/input/src/orxonox/core/ArgReader.cc
===================================================================
--- /code/branches/input/src/orxonox/core/ArgReader.cc	(revision 944)
+++ 	(revision )
@@ -1,113 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Benjamin Knecht <beni_at_orxonox.net>, (C) 2007
- *   Co-authors:
- *      ...
- *
- */
-
-/**
- @file  ArgReader.cc
- @brief Argument Reader
- */
-
-#include <iostream>
-
-#include "ArgReader.h"
-
-namespace orxonox {
-
-  ArgReader::ArgReader(int argc, char** argv)
-  {
-    counter_ = argc;
-    arguments_ = argv;
-    fail_ = false;
-    errorStr_ = "";
-  }
-
-  void ArgReader::checkArgument(std::string option, std::string &string, bool must)
-  {
-    int argpos = checkOption(option) + 1;
-    if(argpos != 0)
-    {
-      string = arguments_[argpos];
-    }
-    else
-    {
-      if(must) {
-        errorStr_ = errorStr_ + "Cannot find mandatory argument \"" + option + "\"\n";
-        fail_ = true;
-      }
-    }
-
-  }
-
-  void ArgReader::checkArgument(std::string option, int &integer, bool must)
-  {
-    int argpos = checkOption(option) + 1;
-    if(argpos != 0)
-    {
-      integer = atoi(arguments_[argpos]);
-    }
-    else
-    {
-      if(must) {
-        errorStr_ = errorStr_ + "Cannot find mandatory argument \"" + option + "\"\n";
-        fail_ = true;
-      }
-    }
-  }
-
-  void ArgReader::checkArgument(std::string option, float &floating, bool must)
-  {
-    int argpos = checkOption(option) + 1;
-    if(argpos != 0)
-    {
-      floating = (float)atof(arguments_[argpos]);
-    }
-    else
-    {
-      if(must) {
-        errorStr_ = errorStr_ + "Cannot find mandatory argument \"" + option + "\"\n";
-        fail_ = true;
-      }
-    }
-  }
-
-  int ArgReader::checkOption(std::string option)
-  {
-    for(int i = 1; i < counter_; i++)
-    {
-      if(arguments_[i] == "--" + option)
-          return i;
-    }
-    return -1;
-  }
-
-  bool ArgReader::errorHandling()
-  {
-    if(fail_)
-      std::cout << errorStr_;
-    return fail_;
-  }
-}
-
Index: de/branches/input/src/orxonox/core/ArgReader.h
===================================================================
--- /code/branches/input/src/orxonox/core/ArgReader.h	(revision 944)
+++ 	(revision )
@@ -1,62 +1,0 @@
-/*
- *   ORXONOX - the hottest 3D action shooter ever to exist
- *
- *
- *   License notice:
- *
- *   This program is free software; you can redistribute it and/or
- *   modify it under the terms of the GNU General Public License
- *   as published by the Free Software Foundation; either version 2
- *   of the License, or (at your option) any later version.
- *
- *   This program is distributed in the hope that it will be useful,
- *   but WITHOUT ANY WARRANTY; without even the implied warranty of
- *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- *   GNU General Public License for more details.
- *
- *   You should have received a copy of the GNU General Public License
- *   along with this program; if not, write to the Free Software
- *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
- *
- *   Author:
- *      Benjamin Knecht <beni_at_orxonox.net>
- *   Co-authors:
- *      ...
- *
- */
-
-/**
- @file  Argreader.h
- @brief reads arguments
- @author Benjamin Knecht <beni_at_orxonox.net>
- */
-
-#ifndef _ArgReader_H__
-#define _ArgReader_H__
-
-#include <string>
-
-#include "CorePrereqs.h"
-
-namespace orxonox {
-
-  class _CoreExport ArgReader
-  {
-    public:
-      ArgReader(int argc, char **argv);
-      void checkArgument(std::string option, std::string& string, bool must=false);
-      void checkArgument(std::string option, int& integer, bool must=false);
-      void checkArgument(std::string option, float& floating, bool must=false);
-      bool errorHandling();
-    private:
-      int checkOption(std::string option);
-
-    private:
-      int counter_;
-      char **arguments_;
-      bool fail_;
-      std::string errorStr_;
-  };
-
-}
-#endif /* _ArgReader_H__ */
Index: /code/branches/input/src/orxonox/core/CMakeLists.txt
===================================================================
--- /code/branches/input/src/orxonox/core/CMakeLists.txt	(revision 944)
+++ /code/branches/input/src/orxonox/core/CMakeLists.txt	(revision 945)
@@ -9,5 +9,4 @@
   Error.cc
   SignalHandler.cc
-  ArgReader.cc
   DebugLevel.cc
   OutputHandler.cc
Index: /code/branches/input/src/orxonox/core/CorePrereqs.h
===================================================================
--- /code/branches/input/src/orxonox/core/CorePrereqs.h	(revision 944)
+++ /code/branches/input/src/orxonox/core/CorePrereqs.h	(revision 945)
@@ -27,6 +27,6 @@
 
 /**
-    @file  CorePrereq.h
-    @brief Contains all the necessary forward declarations for all classes, structs and enums.
+  @file
+  @brief Contains all the necessary forward declarations for all classes and structs.
 */
 
@@ -67,7 +67,7 @@
   typedef std::string LanguageEntryLabel;
 
-  class ArgReader;
   class BaseFactory;
   class BaseMetaObjectListElement;
+  class BaseObject;
   template <class T>
   class ClassFactory;
@@ -103,4 +103,5 @@
   template <class T>
   class SubclassIdentifier;
+  class Tickable;
   template <class T, class O>
   class XMLPortClassObjectContainer;
Index: /code/branches/input/src/util/ArgReader.cc
===================================================================
--- /code/branches/input/src/util/ArgReader.cc	(revision 945)
+++ /code/branches/input/src/util/ArgReader.cc	(revision 945)
@@ -0,0 +1,109 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Benjamin Knecht <beni_at_orxonox.net>, (C) 2007
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file  ArgReader.cc
+ @brief Argument Reader
+ */
+
+#include <iostream>
+
+#include "ArgReader.h"
+
+ArgReader::ArgReader(int argc, char** argv)
+{
+  counter_ = argc;
+  arguments_ = argv;
+  fail_ = false;
+  errorStr_ = "";
+}
+
+void ArgReader::checkArgument(std::string option, std::string &string, bool must)
+{
+  int argpos = checkOption(option) + 1;
+  if(argpos != 0)
+  {
+    string = arguments_[argpos];
+  }
+  else
+  {
+    if(must) {
+      errorStr_ = errorStr_ + "Cannot find mandatory argument \"" + option + "\"\n";
+      fail_ = true;
+    }
+  }
+
+}
+
+void ArgReader::checkArgument(std::string option, int &integer, bool must)
+{
+  int argpos = checkOption(option) + 1;
+  if(argpos != 0)
+  {
+    integer = atoi(arguments_[argpos]);
+  }
+  else
+  {
+    if(must) {
+      errorStr_ = errorStr_ + "Cannot find mandatory argument \"" + option + "\"\n";
+      fail_ = true;
+    }
+  }
+}
+
+void ArgReader::checkArgument(std::string option, float &floating, bool must)
+{
+  int argpos = checkOption(option) + 1;
+  if(argpos != 0)
+  {
+    floating = (float)atof(arguments_[argpos]);
+  }
+  else
+  {
+    if(must) {
+      errorStr_ = errorStr_ + "Cannot find mandatory argument \"" + option + "\"\n";
+      fail_ = true;
+    }
+  }
+}
+
+int ArgReader::checkOption(std::string option)
+{
+  for(int i = 1; i < counter_; i++)
+  {
+    if(arguments_[i] == "--" + option)
+        return i;
+  }
+  return -1;
+}
+
+bool ArgReader::errorHandling()
+{
+  if(fail_)
+    std::cout << errorStr_;
+  return fail_;
+}
Index: /code/branches/input/src/util/ArgReader.h
===================================================================
--- /code/branches/input/src/util/ArgReader.h	(revision 945)
+++ /code/branches/input/src/util/ArgReader.h	(revision 945)
@@ -0,0 +1,59 @@
+/*
+ *   ORXONOX - the hottest 3D action shooter ever to exist
+ *
+ *
+ *   License notice:
+ *
+ *   This program is free software; you can redistribute it and/or
+ *   modify it under the terms of the GNU General Public License
+ *   as published by the Free Software Foundation; either version 2
+ *   of the License, or (at your option) any later version.
+ *
+ *   This program is distributed in the hope that it will be useful,
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *   GNU General Public License for more details.
+ *
+ *   You should have received a copy of the GNU General Public License
+ *   along with this program; if not, write to the Free Software
+ *   Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
+ *
+ *   Author:
+ *      Benjamin Knecht <beni_at_orxonox.net>
+ *   Co-authors:
+ *      ...
+ *
+ */
+
+/**
+ @file  Argreader.h
+ @brief reads arguments
+ @author Benjamin Knecht <beni_at_orxonox.net>
+ */
+
+#ifndef _ArgReader_H__
+#define _ArgReader_H__
+
+#include <string>
+
+#include "UtilPrereqs.h"
+
+class _UtilExport ArgReader
+{
+  public:
+    ArgReader(int argc, char **argv);
+    void checkArgument(std::string option, std::string& string, bool must=false);
+    void checkArgument(std::string option, int& integer, bool must=false);
+    void checkArgument(std::string option, float& floating, bool must=false);
+    bool errorHandling();
+  private:
+    int checkOption(std::string option);
+
+  private:
+    int counter_;
+    char **arguments_;
+    bool fail_;
+    std::string errorStr_;
+};
+
+#endif /* _ArgReader_H__ */
Index: /code/branches/input/src/util/CMakeLists.txt
===================================================================
--- /code/branches/input/src/util/CMakeLists.txt	(revision 944)
+++ /code/branches/input/src/util/CMakeLists.txt	(revision 945)
@@ -4,4 +4,5 @@
 
 SET (UTIL_SRC_FILES
+  ArgReader.cc
   Math.cc
   String.cc
Index: /code/branches/input/src/util/UtilPrereqs.h
===================================================================
--- /code/branches/input/src/util/UtilPrereqs.h	(revision 944)
+++ /code/branches/input/src/util/UtilPrereqs.h	(revision 945)
@@ -27,7 +27,7 @@
 
 /**
- @file  UtilPrereq.h
- @brief Contains all the necessary forward declarations for all classes, structs and enums.
- */
+  @file
+  @brief Contains all the necessary forward declarations for all classes and structs.
+*/
 
 #ifndef _UtilPrereqs_H__
@@ -59,4 +59,5 @@
 // Forward declarations
 //-----------------------------------------------------------------------
+class ArgReader;
 class Convert;
 template <typename FromType, typename ToType>
Index: /code/branches/input/visual_studio/vc8/audio.vcproj
===================================================================
--- /code/branches/input/visual_studio/vc8/audio.vcproj	(revision 944)
+++ /code/branches/input/visual_studio/vc8/audio.vcproj	(revision 945)
@@ -273,40 +273,4 @@
 			>
 			<File
-				RelativePath="..\..\src\audio\_AudioObject.cc"
-				>
-				<FileConfiguration
-					Name="Debug|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release_SSE|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release_SSE2|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-			</File>
-			<File
 				RelativePath="..\..\src\audio\AudioBuffer.cc"
 				>
Index: /code/branches/input/visual_studio/vc8/core.vcproj
===================================================================
--- /code/branches/input/visual_studio/vc8/core.vcproj	(revision 944)
+++ /code/branches/input/visual_studio/vc8/core.vcproj	(revision 945)
@@ -273,8 +273,4 @@
 			>
 			<File
-				RelativePath="..\..\src\orxonox\core\ArgReader.cc"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\orxonox\core\BaseObject.cc"
 				>
@@ -351,8 +347,4 @@
 			>
 			<File
-				RelativePath="..\..\src\orxonox\core\ArgReader.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\orxonox\core\BaseObject.h"
 				>
Index: /code/branches/input/visual_studio/vc8/network.vcproj
===================================================================
--- /code/branches/input/visual_studio/vc8/network.vcproj	(revision 944)
+++ /code/branches/input/visual_studio/vc8/network.vcproj	(revision 945)
@@ -481,40 +481,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\network\PacketBufferTestExt.cc"
-				>
-				<FileConfiguration
-					Name="Debug|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release_SSE|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release_SSE2|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-			</File>
-			<File
 				RelativePath="..\..\src\network\PacketDecoder.cc"
 				>
Index: /code/branches/input/visual_studio/vc8/orxonox.vcproj
===================================================================
--- /code/branches/input/visual_studio/vc8/orxonox.vcproj	(revision 944)
+++ /code/branches/input/visual_studio/vc8/orxonox.vcproj	(revision 945)
@@ -293,16 +293,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\orxonox\InputManager.cc"
-				>
-				<FileConfiguration
-					Name="Debug|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-			</File>
-			<File
 				RelativePath="..\..\src\orxonox\Main.cc"
 				>
@@ -348,40 +336,4 @@
 				</FileConfiguration>
 			</File>
-			<File
-				RelativePath="..\..\src\orxonox\SpaceshipSteering.cc"
-				>
-				<FileConfiguration
-					Name="Debug|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release_SSE|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-				<FileConfiguration
-					Name="Release_SSE2|Win32"
-					ExcludedFromBuild="true"
-					>
-					<Tool
-						Name="VCCLCompilerTool"
-					/>
-				</FileConfiguration>
-			</File>
 			<Filter
 				Name="hud"
@@ -430,160 +382,4 @@
 					RelativePath="..\..\src\orxonox\objects\SpaceShip.cc"
 					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\SpaceshipSteeringObject.cc"
-					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release_SSE|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release_SSE2|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-						/>
-					</FileConfiguration>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\test1.cc"
-					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release_SSE|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release_SSE2|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\test2.cc"
-					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release_SSE|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release_SSE2|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\test3.cc"
-					>
-					<FileConfiguration
-						Name="Debug|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release_SSE|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
-					<FileConfiguration
-						Name="Release_SSE2|Win32"
-						ExcludedFromBuild="true"
-						>
-						<Tool
-							Name="VCCLCompilerTool"
-							UsePrecompiledHeader="0"
-						/>
-					</FileConfiguration>
 				</File>
 				<File
@@ -671,8 +467,4 @@
 			</File>
 			<File
-				RelativePath="..\..\src\orxonox\InputManager.h"
-				>
-			</File>
-			<File
 				RelativePath="..\..\src\orxonox\Orxonox.h"
 				>
@@ -690,8 +482,4 @@
 				>
 			</File>
-			<File
-				RelativePath="..\..\src\orxonox\SpaceshipSteering.h"
-				>
-			</File>
 			<Filter
 				Name="hud"
@@ -739,24 +527,4 @@
 				<File
 					RelativePath="..\..\src\orxonox\objects\SpaceShip.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\SpaceshipSteeringObject.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\Test.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\test1.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\test2.h"
-					>
-				</File>
-				<File
-					RelativePath="..\..\src\orxonox\objects\test3.h"
 					>
 				</File>
Index: /code/branches/input/visual_studio/vc8/util.vcproj
===================================================================
--- /code/branches/input/visual_studio/vc8/util.vcproj	(revision 944)
+++ /code/branches/input/visual_studio/vc8/util.vcproj	(revision 945)
@@ -273,4 +273,8 @@
 			>
 			<File
+				RelativePath="..\..\src\util\ArgReader.cc"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\util\Math.cc"
 				>
@@ -293,5 +297,5 @@
 			</File>
 			<File
-				RelativePath="..\..\src\util\substring.cc"
+				RelativePath="..\..\src\util\SubString.cc"
 				>
 			</File>
@@ -303,4 +307,8 @@
 			>
 			<File
+				RelativePath="..\..\src\util\ArgReader.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\src\util\Convert.h"
 				>
@@ -339,5 +347,5 @@
 			</File>
 			<File
-				RelativePath="..\..\src\util\substring.h"
+				RelativePath="..\..\src\util\SubString.h"
 				>
 			</File>